﻿// Copyright © 2019 UiPath. All rights reserved.

using System.Activities.Presentation.Metadata;
using System.ComponentModel;

namespace UiPathTeam.ParallelTest.Activities.Design
{
    public class DesignerMetadata : IRegisterMetadata
    {
        public void Register()
        {
            var builder = new AttributeTableBuilder();
            builder.AddCustomAttributes(type: typeof(AsyncWriteLine), attributes: new DesignerAttribute(typeof(RepeatSomethingDesigner)));
            builder.AddCustomAttributes(type: typeof(SyncWriteLine), attributes: new DesignerAttribute(typeof(RepeatSomethingDesigner)));
            var category = new CategoryAttribute("UiPathTeam.並列テスト");
            builder.AddCustomAttributes(type: typeof(AsyncWriteLine), attributes: category);
            builder.AddCustomAttributes(type: typeof(SyncWriteLine), attributes: category);
            MetadataStore.AddAttributeTable(builder.CreateTable());
        }
    }
}
