﻿// Copyright © 2019 UiPath. All rights reserved.

using System;
using System.Activities;
using System.ComponentModel;

namespace UiPathTeam.ParallelTest.Activities
{
    [DisplayName("非同期アクティビティ")]
    public class AsyncWriteLine : AsyncCodeActivity
    {
        [DisplayName("メッセージ")]
        [Category("入力")]
        public InArgument<string> Message { get; set; }

        [DisplayName("回数")]
        [Category("入力")]
        public InArgument<int> Repetition { get; set; }

        [DisplayName("インターバル(ミリ秒)")]
        [Category("入力")]
        public InArgument<int> Interval { get; set; }

        [DisplayName("画像ファイルのパス")]
        [Category("入力(デザイン時)")]
        public string ImagePath { get; set; }

        private delegate void RepeatWriteLine(string message, int repetition, int interval);

        protected override IAsyncResult BeginExecute(AsyncCodeActivityContext context, AsyncCallback callback, object state)
        {
            var TheDelegate = new RepeatWriteLine(Helper.RepeatWriteLine);
            context.UserState = TheDelegate;
            return TheDelegate.BeginInvoke(Message.Get(context), Repetition.Get(context), Interval.Get(context), callback, state);
        }

        protected override void EndExecute(AsyncCodeActivityContext context, IAsyncResult result)
        {
            var TheDelegate = context.UserState as RepeatWriteLine;
            TheDelegate.EndInvoke(result);
        }
    }
}
